package net.mcreator.unco_mod.procedure;

import net.minecraft.world.World;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.ResourceLocation;
import net.minecraft.init.Blocks;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.Entity;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.properties.IProperty;

import net.mcreator.unco_mod.block.BlockSpruce_Door_Steampunk_Upper;
import net.mcreator.unco_mod.block.BlockSpruce_Door_Steampunk_Lower;
import net.mcreator.unco_mod.ElementsUNCOMod;

@ElementsUNCOMod.ModElement.Tag
public class ProcedureSpruceDoorSteampunkRightClickedOnBlock extends ElementsUNCOMod.ModElement {
	public ProcedureSpruceDoorSteampunkRightClickedOnBlock(ElementsUNCOMod instance) {
		super(instance, 44);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("entity") == null) {
			System.err.println("Failed to load dependency entity for procedure SpruceDoorSteampunkRightClickedOnBlock!");
			return;
		}
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure SpruceDoorSteampunkRightClickedOnBlock!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure SpruceDoorSteampunkRightClickedOnBlock!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure SpruceDoorSteampunkRightClickedOnBlock!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure SpruceDoorSteampunkRightClickedOnBlock!");
			return;
		}
		Entity entity = (Entity) dependencies.get("entity");
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		if ((((world.getBlockState(new BlockPos((int) x, (int) (y + 1), (int) z))).getBlock() == Blocks.AIR.getDefaultState().getBlock())
				&& ((world.getBlockState(new BlockPos((int) x, (int) (y + 2), (int) z))).getBlock() == Blocks.AIR.getDefaultState().getBlock()))) {
			world.setBlockState(new BlockPos((int) x, (int) (y + 1), (int) z), BlockSpruce_Door_Steampunk_Lower.block.getDefaultState(), 3);
			try {
				IBlockState _bs = world.getBlockState(new BlockPos((int) x, (int) (y + 1), (int) z));
				for (IProperty<?> prop : _bs.getProperties().keySet()) {
					if (prop.getName().equals("facing")) {
						world.setBlockState(new BlockPos((int) x, (int) (y + 1), (int) z),
								_bs.withProperty((PropertyDirection) prop, ((entity.getHorizontalFacing()).getOpposite())), 3);
						break;
					}
				}
			} catch (Exception e) {
			}
			world.setBlockState(new BlockPos((int) x, (int) (y + 2), (int) z), BlockSpruce_Door_Steampunk_Upper.block.getDefaultState(), 3);
			try {
				IBlockState _bs = world.getBlockState(new BlockPos((int) x, (int) (y + 2), (int) z));
				for (IProperty<?> prop : _bs.getProperties().keySet()) {
					if (prop.getName().equals("facing")) {
						world.setBlockState(new BlockPos((int) x, (int) (y + 2), (int) z),
								_bs.withProperty((PropertyDirection) prop, ((entity.getHorizontalFacing()).getOpposite())), 3);
						break;
					}
				}
			} catch (Exception e) {
			}
		}
		world.playSound((EntityPlayer) null, x, y, z,
				(net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation("block.wood.place")),
				SoundCategory.NEUTRAL, (float) 1, (float) 0.7);
	}
}
